#include <stdio.h>
#include <math.h>

int factorial(int m)
{
    if (m==0 || m==1) {
		return (1);
	}
    else {     
		return (m*factorial(m-1));
	}
}
int power(int x,int n)
{
    int val=1;
    int i=1;
    while (i<=n)
    {
        val*=x;
		i++;
    }
    return val;
}

int sine(int x)
{
    int n;
    int val=0;
	int p;
	int px;
	int fac;
    for (n=0;n<8;n++)
    {
        p = power(-1,n);
        px = power(x,2*n+1);
        fac = factorial(2*n+1);
        val += p * px / fac;
    }
    return val;
}

int main()
{
    int x;
    printf("Enter angles in degrees: ");
    scanf("%lf",&x);
    printf("\nValue of sine of %.2f is %.2lf\n",x,sine(x * M_PI / 180));
    printf("\nValue of sine of %.2f from library function is %.2lf\n",x,sin(x * M_PI / 180));
    return 0;
}


