#include	<stdio.h>
#include	<stdlib.h>
#include        "List.h"
//Type List: https://fr.wikibooks.org/wiki/Structures_de_donn%C3%A9es_en_C/Les_listes_simples#Type_List_en_C



List * list_create (void *data)
{
   List *list = malloc(sizeof(list)); /* allocation et affectation à la variable list  */
   if (list)                           /* si l'allocation a réussi */
   {
       list->data = data;              /* affectation du champ data */
       list->next = NULL;              /* affectation du champ next à la liste vide */
   }
   return list;                        /* retour de la liste (correctement allouée et affectée ou NULL) */
 }


List * list_create_empty ()
{
   List *list = malloc(sizeof(list)); /* allocation et affectation à la variable list  */
   return list;                        /* retour de la liste (correctement allouée et affectée ou NULL) */
 }

List * list_prepend(List *old, void *data)
{
    List *list = list_create(data); /* création et affectation d'une liste d'un élément */
    if (list)                       /* si l'allocation mémoire a réussi */
       list->next = old;             /* accrochage de l'ancienne liste à la nouvelle   */
    return list;                    /* retour de la nouvelle liste (ou NULL si l'allocation a échoué) */
}

List * list_append(List *list, void *data)
{
    List **plist = &list;
    while (*plist)
       plist = &(*plist)->next;
    *plist = list_create(data);
    if (*plist)
       return list;
    else
       return NULL;
}

