#define max(a,b) (a>=b?a:b)
#define min(a,b) (a<=b?a:b)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "nbLigne.c"
#include "tabl.h"

//Fonction créant un tableau à 2 dimensions contenant une fonction par ligne, chaque ligne contenant un tableau des mots d'une fonction
char*** tableau(char* s){
	char* pch;
	int i,j,k;
	int max1=0;
	char *s1=malloc(strlen(s)*sizeof(char));
	char *s2=malloc(strlen(s)*sizeof(char));
	strcpy(s1,s);
	strcpy(s2,s);
	//Calcul du nombre de ligne/fonctions
	int nb=nbLigne(s1);
	i=0;
	pch = strtok (s1,"\n");
	//Calcul du nombre maximal de paramètre permettant d'initialiser le tableau
	while (pch != NULL)
	{
		strcpy(s2,pch);
		j=nbParam(s2);
		max1=max(max1,j);
		pch = strtok (NULL, "\n");
		i++;
	}
	//Création du tableau
	char* **tableau = malloc(nb*sizeof(char*));
	for (i=0;i<nb;i++){
		tableau[i] = malloc(max1*sizeof(char*));
	}
	//Initialisation du tableau
	for(i=0;i<nb;i++){
		for(j=0;j<max1;j++){
			tableau[i][j]="";
		}
	}

	i=0;
	j=0;
	k=0;
	pch = strtok (s," ");
	//Ecriture du tableau
	while (pch != NULL)
	{
		//On différencie les accolades du reste afin de savoir lorsque qu'une fonction se finie
		if((strcmp(pch,"{"))==0){
			k++;
			tableau[i][j]="{";
			j++;
		}else if((strcmp(pch,"}"))==0){
			k--;
			tableau[i][j]="}";
			j++;
			if (k==0){
				i++;
				j=0;
			}		
		}else if(!(strcmp(pch,"\n")==0)){
			tableau[i][j]=pch;
			j++;
		}
		pch = strtok (NULL, " \n\r");
	}
	return tableau;
}

